import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { EventEmitter, Component, Input, Output, CUSTOM_ELEMENTS_SCHEMA, NgModule } from '@angular/core';
import * as i2 from 'primeng/table';
import { TableModule } from 'primeng/table';
import * as i3 from 'primeng/api';

class ButtonComponent {
    label = 'Click Me'; // Button text
    variant = 'primary'; // primary, secondary, success, danger
    size = 'medium'; // small, medium, large
    disabled = false; // Disable button
    click = new EventEmitter();
    //Access Modifiers need to use
    onButtonClick(event) {
        if (!this.disabled) {
            this.click.emit(event);
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: ButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.2", type: ButtonComponent, isStandalone: true, selector: "lib-button", inputs: { label: "label", variant: "variant", size: "size", disabled: "disabled" }, outputs: { click: "click" }, ngImport: i0, template: "<button\r\n[ngClass]=\"['stylish-button', variant, size]\"\r\n[disabled]=\"disabled\"\r\n(click)=\"onButtonClick($event)\"\r\n>\r\n{{ label }}\r\n</button>", styles: [".stylish-button{display:inline-block;padding:.75rem 1.5rem;font-size:1rem;font-weight:600;color:#fff;background-color:#007bff;border:none;border-radius:5px;cursor:pointer;transition:all .3s ease-in-out}.stylish-button:hover{background-color:#0056b3;box-shadow:0 4px 6px #0000001a}.stylish-button:disabled{background-color:#d6d6d6;cursor:not-allowed}.stylish-button.primary{background-color:#007bff}.stylish-button.secondary{background-color:#6c757d}.stylish-button.success{background-color:#28a745}.stylish-button.danger{background-color:#dc3545}.stylish-button.small{padding:.5rem 1rem;font-size:.875rem}.stylish-button.medium{padding:.75rem 1.5rem;font-size:1rem}.stylish-button.large{padding:1rem 2rem;font-size:1.25rem}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: ButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-button', imports: [CommonModule], standalone: true, template: "<button\r\n[ngClass]=\"['stylish-button', variant, size]\"\r\n[disabled]=\"disabled\"\r\n(click)=\"onButtonClick($event)\"\r\n>\r\n{{ label }}\r\n</button>", styles: [".stylish-button{display:inline-block;padding:.75rem 1.5rem;font-size:1rem;font-weight:600;color:#fff;background-color:#007bff;border:none;border-radius:5px;cursor:pointer;transition:all .3s ease-in-out}.stylish-button:hover{background-color:#0056b3;box-shadow:0 4px 6px #0000001a}.stylish-button:disabled{background-color:#d6d6d6;cursor:not-allowed}.stylish-button.primary{background-color:#007bff}.stylish-button.secondary{background-color:#6c757d}.stylish-button.success{background-color:#28a745}.stylish-button.danger{background-color:#dc3545}.stylish-button.small{padding:.5rem 1rem;font-size:.875rem}.stylish-button.medium{padding:.75rem 1.5rem;font-size:1rem}.stylish-button.large{padding:1rem 2rem;font-size:1.25rem}\n"] }]
        }], propDecorators: { label: [{
                type: Input
            }], variant: [{
                type: Input
            }], size: [{
                type: Input
            }], disabled: [{
                type: Input
            }], click: [{
                type: Output
            }] } });

class CalenderComponent {
    showCalendar = false;
    selectedDate = '';
    days = [];
    currentMonth = new Date().getMonth();
    currentYear = new Date().getFullYear();
    monthNames = [
        'January',
        'February',
        'March',
        'April',
        'May',
        'June',
        'July',
        'August',
        'September',
        'October',
        'November',
        'December',
    ];
    constructor() {
        this.generateDays();
    }
    toggleCalendar() {
        this.showCalendar = !this.showCalendar;
    }
    generateDays() {
        this.days = [];
        const firstDay = new Date(this.currentYear, this.currentMonth, 1);
        const lastDay = new Date(this.currentYear, this.currentMonth + 1, 0);
        for (let i = 1; i <= lastDay.getDate(); i++) {
            this.days.push({
                date: i,
                fullDate: new Date(this.currentYear, this.currentMonth, i),
            });
        }
    }
    selectDate(day) {
        this.selectedDate = day.fullDate.toISOString().split('T')[0];
        this.showCalendar = false;
    }
    navigateMonth(direction) {
        this.currentMonth += direction;
        if (this.currentMonth < 0) {
            this.currentMonth = 11;
            this.currentYear--;
        }
        else if (this.currentMonth > 11) {
            this.currentMonth = 0;
            this.currentYear++;
        }
        this.generateDays();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: CalenderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.2", type: CalenderComponent, isStandalone: true, selector: "lib-calender", ngImport: i0, template: "<div class=\"date-picker\">\r\n  \r\n    <input\r\n      type=\"text\"\r\n      [value]=\"selectedDate\"\r\n      placeholder=\"Select a date\"\r\n      readonly\r\n      (click)=\"toggleCalendar()\"\r\n    />\r\n  \r\n   \r\n    <div class=\"calendar\" *ngIf=\"showCalendar\">\r\n     \r\n      <div class=\"calendar-header\">\r\n        <button (click)=\"navigateMonth(-1)\">&#8249;</button>\r\n        <span>{{ monthNames[currentMonth] }} {{ currentYear }}</span>\r\n        <button (click)=\"navigateMonth(1)\">&#8250;</button>\r\n      </div>\r\n  \r\n     \r\n      <div class=\"calendar-grid\">\r\n        <div\r\n          class=\"calendar-day\"\r\n          *ngFor=\"let day of days\"\r\n          (click)=\"selectDate(day)\"\r\n        >\r\n          {{ day.date }}\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  ", styles: [".date-picker{position:relative;display:inline-block}input{width:200px;padding:8px;border:1px solid #ccc;border-radius:4px;cursor:pointer}.calendar{position:absolute;top:40px;left:0;width:250px;border:1px solid #ccc;border-radius:8px;background:#fff;box-shadow:0 4px 8px #0000001a;z-index:10}.calendar-header{display:flex;justify-content:space-between;align-items:center;padding:10px;background:#f9f9f9;border-bottom:1px solid #ddd}.calendar-header span{font-weight:700}.calendar-header button{background:none;border:none;font-size:16px;cursor:pointer}.calendar-grid{display:grid;grid-template-columns:repeat(7,1fr);gap:5px;padding:10px}.calendar-day{text-align:center;padding:8px;cursor:pointer;border-radius:4px}.calendar-day:hover,.calendar-day.selected{background:#007bff;color:#fff}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: CalenderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-calender', imports: [CommonModule], standalone: true, template: "<div class=\"date-picker\">\r\n  \r\n    <input\r\n      type=\"text\"\r\n      [value]=\"selectedDate\"\r\n      placeholder=\"Select a date\"\r\n      readonly\r\n      (click)=\"toggleCalendar()\"\r\n    />\r\n  \r\n   \r\n    <div class=\"calendar\" *ngIf=\"showCalendar\">\r\n     \r\n      <div class=\"calendar-header\">\r\n        <button (click)=\"navigateMonth(-1)\">&#8249;</button>\r\n        <span>{{ monthNames[currentMonth] }} {{ currentYear }}</span>\r\n        <button (click)=\"navigateMonth(1)\">&#8250;</button>\r\n      </div>\r\n  \r\n     \r\n      <div class=\"calendar-grid\">\r\n        <div\r\n          class=\"calendar-day\"\r\n          *ngFor=\"let day of days\"\r\n          (click)=\"selectDate(day)\"\r\n        >\r\n          {{ day.date }}\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  ", styles: [".date-picker{position:relative;display:inline-block}input{width:200px;padding:8px;border:1px solid #ccc;border-radius:4px;cursor:pointer}.calendar{position:absolute;top:40px;left:0;width:250px;border:1px solid #ccc;border-radius:8px;background:#fff;box-shadow:0 4px 8px #0000001a;z-index:10}.calendar-header{display:flex;justify-content:space-between;align-items:center;padding:10px;background:#f9f9f9;border-bottom:1px solid #ddd}.calendar-header span{font-weight:700}.calendar-header button{background:none;border:none;font-size:16px;cursor:pointer}.calendar-grid{display:grid;grid-template-columns:repeat(7,1fr);gap:5px;padding:10px}.calendar-day{text-align:center;padding:8px;cursor:pointer;border-radius:4px}.calendar-day:hover,.calendar-day.selected{background:#007bff;color:#fff}\n"] }]
        }], ctorParameters: () => [] });

class FileuploadComponent {
    selectedFile = null;
    fileUploaded = new EventEmitter();
    onFileSelected(event) {
        const input = event.target;
        if (input.files && input.files.length > 0) {
            this.selectedFile = input.files[0];
        }
    }
    uploadFile() {
        if (this.selectedFile) {
            this.fileUploaded.emit(this.selectedFile);
        }
    }
    clearFile() {
        this.selectedFile = null;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: FileuploadComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.2", type: FileuploadComponent, isStandalone: true, selector: "lib-fileupload", outputs: { fileUploaded: "fileUploaded" }, ngImport: i0, template: "<div class=\"file-upload-container\">\r\n  \r\n    <input type=\"file\" (change)=\"onFileSelected($event)\" />\r\n  \r\n   \r\n    <p *ngIf=\"selectedFile\">Selected File: {{ selectedFile.name }}</p>\r\n  \r\n\r\n    <div class=\"action-buttons\">\r\n      <button (click)=\"uploadFile()\" [disabled]=\"!selectedFile\">Upload</button>\r\n      <button (click)=\"clearFile()\" [disabled]=\"!selectedFile\">Clear</button>\r\n    </div>\r\n  </div>\r\n  ", styles: [".file-upload-container{display:flex;flex-direction:column;gap:10px;border:1px solid #ccc;padding:15px;border-radius:5px;max-width:300px}.action-buttons{display:flex;gap:10px}button{padding:5px 10px;border:none;border-radius:4px;background-color:#007bff;color:#fff;cursor:pointer}button[disabled]{background-color:#ccc;cursor:not-allowed}button:hover:not([disabled]){background-color:#0056b3}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: FileuploadComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-fileupload', imports: [CommonModule], template: "<div class=\"file-upload-container\">\r\n  \r\n    <input type=\"file\" (change)=\"onFileSelected($event)\" />\r\n  \r\n   \r\n    <p *ngIf=\"selectedFile\">Selected File: {{ selectedFile.name }}</p>\r\n  \r\n\r\n    <div class=\"action-buttons\">\r\n      <button (click)=\"uploadFile()\" [disabled]=\"!selectedFile\">Upload</button>\r\n      <button (click)=\"clearFile()\" [disabled]=\"!selectedFile\">Clear</button>\r\n    </div>\r\n  </div>\r\n  ", styles: [".file-upload-container{display:flex;flex-direction:column;gap:10px;border:1px solid #ccc;padding:15px;border-radius:5px;max-width:300px}.action-buttons{display:flex;gap:10px}button{padding:5px 10px;border:none;border-radius:4px;background-color:#007bff;color:#fff;cursor:pointer}button[disabled]{background-color:#ccc;cursor:not-allowed}button:hover:not([disabled]){background-color:#0056b3}\n"] }]
        }], propDecorators: { fileUploaded: [{
                type: Output
            }] } });

class GridComponent {
    columns = []; // Dynamic columns
    data = []; // Dynamic row data
    selectedRow = null;
    toggleRowDetails(row) {
        this.selectedRow = this.selectedRow === row ? null : row;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: GridComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.2", type: GridComponent, isStandalone: true, selector: "lib-grid", inputs: { columns: "columns", data: "data" }, ngImport: i0, template: "<p-table [columns]=\"columns\" [value]=\"data\" [tableStyle]=\"{ 'min-width': '50rem' }\">\r\n  <ng-template pTemplate=\"header\">\r\n    <tr>\r\n      <th *ngFor=\"let col of columns\">\r\n        {{ col.header }}\r\n      </th>\r\n    </tr>\r\n  </ng-template>\r\n\r\n  <ng-template pTemplate=\"body\" let-rowData>\r\n    <tr>\r\n      <td *ngFor=\"let col of columns\">\r\n        {{ rowData[col.field] }}\r\n      </td>\r\n      <td>\r\n        <button pButton label=\"View Details\" (click)=\"toggleRowDetails(rowData)\" class=\"p-button-text p-button-sm\">View Details</button>\r\n      </td>\r\n    </tr>\r\n  </ng-template>\r\n</p-table>\r\n\r\n<div *ngIf=\"selectedRow\" class=\"p-3 border-round bg-gray-200 mt-3\">\r\n  <strong>Row Details:</strong>\r\n  <pre>{{ selectedRow | json }}</pre>\r\n</div>", styles: [".table-container{width:100%;margin:20px 0;font-family:Arial,sans-serif}.table{width:100%;border-collapse:collapse;margin-bottom:10px}.table th,.table td{padding:10px;border:1px solid #ddd;text-align:left}.table th{background-color:#f4f4f4}.pagination{display:flex;justify-content:center;align-items:center}.pagination button{margin:0 10px;padding:5px 15px;background-color:#007bff;color:#fff;border:none;cursor:pointer}.pagination button:disabled{background-color:#ccc;cursor:not-allowed}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i1.JsonPipe, name: "json" }, { kind: "ngmodule", type: TableModule }, { kind: "component", type: i2.Table, selector: "p-table", inputs: ["frozenColumns", "frozenValue", "style", "styleClass", "tableStyle", "tableStyleClass", "paginator", "pageLinks", "rowsPerPageOptions", "alwaysShowPaginator", "paginatorPosition", "paginatorStyleClass", "paginatorDropdownAppendTo", "paginatorDropdownScrollHeight", "currentPageReportTemplate", "showCurrentPageReport", "showJumpToPageDropdown", "showJumpToPageInput", "showFirstLastIcon", "showPageLinks", "defaultSortOrder", "sortMode", "resetPageOnSort", "selectionMode", "selectionPageOnly", "contextMenuSelection", "contextMenuSelectionMode", "dataKey", "metaKeySelection", "rowSelectable", "rowTrackBy", "lazy", "lazyLoadOnInit", "compareSelectionBy", "csvSeparator", "exportFilename", "filters", "globalFilterFields", "filterDelay", "filterLocale", "expandedRowKeys", "editingRowKeys", "rowExpandMode", "scrollable", "scrollDirection", "rowGroupMode", "scrollHeight", "virtualScroll", "virtualScrollItemSize", "virtualScrollOptions", "virtualScrollDelay", "frozenWidth", "responsive", "contextMenu", "resizableColumns", "columnResizeMode", "reorderableColumns", "loading", "loadingIcon", "showLoader", "rowHover", "customSort", "showInitialSortBadge", "autoLayout", "exportFunction", "exportHeader", "stateKey", "stateStorage", "editMode", "groupRowsBy", "groupRowsByOrder", "responsiveLayout", "breakpoint", "paginatorLocale", "value", "columns", "first", "rows", "totalRecords", "sortField", "sortOrder", "multiSortMeta", "selection", "selectAll", "virtualRowHeight"], outputs: ["contextMenuSelectionChange", "selectAllChange", "selectionChange", "onRowSelect", "onRowUnselect", "onPage", "onSort", "onFilter", "onLazyLoad", "onRowExpand", "onRowCollapse", "onContextMenuSelect", "onColResize", "onColReorder", "onRowReorder", "onEditInit", "onEditComplete", "onEditCancel", "onHeaderCheckboxToggle", "sortFunction", "firstChange", "rowsChange", "onStateSave", "onStateRestore"] }, { kind: "directive", type: i3.PrimeTemplate, selector: "[pTemplate]", inputs: ["type", "pTemplate"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: GridComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-grid', imports: [CommonModule, TableModule], standalone: true, schemas: [CUSTOM_ELEMENTS_SCHEMA], template: "<p-table [columns]=\"columns\" [value]=\"data\" [tableStyle]=\"{ 'min-width': '50rem' }\">\r\n  <ng-template pTemplate=\"header\">\r\n    <tr>\r\n      <th *ngFor=\"let col of columns\">\r\n        {{ col.header }}\r\n      </th>\r\n    </tr>\r\n  </ng-template>\r\n\r\n  <ng-template pTemplate=\"body\" let-rowData>\r\n    <tr>\r\n      <td *ngFor=\"let col of columns\">\r\n        {{ rowData[col.field] }}\r\n      </td>\r\n      <td>\r\n        <button pButton label=\"View Details\" (click)=\"toggleRowDetails(rowData)\" class=\"p-button-text p-button-sm\">View Details</button>\r\n      </td>\r\n    </tr>\r\n  </ng-template>\r\n</p-table>\r\n\r\n<div *ngIf=\"selectedRow\" class=\"p-3 border-round bg-gray-200 mt-3\">\r\n  <strong>Row Details:</strong>\r\n  <pre>{{ selectedRow | json }}</pre>\r\n</div>", styles: [".table-container{width:100%;margin:20px 0;font-family:Arial,sans-serif}.table{width:100%;border-collapse:collapse;margin-bottom:10px}.table th,.table td{padding:10px;border:1px solid #ddd;text-align:left}.table th{background-color:#f4f4f4}.pagination{display:flex;justify-content:center;align-items:center}.pagination button{margin:0 10px;padding:5px 15px;background-color:#007bff;color:#fff;border:none;cursor:pointer}.pagination button:disabled{background-color:#ccc;cursor:not-allowed}\n"] }]
        }], propDecorators: { columns: [{
                type: Input
            }], data: [{
                type: Input
            }] } });

class SharedComponentModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: SharedComponentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.1.2", ngImport: i0, type: SharedComponentModule, imports: [CommonModule] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: SharedComponentModule, imports: [CommonModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.2", ngImport: i0, type: SharedComponentModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [
                        CommonModule
                    ]
                }]
        }] });

/*
 * Public API Surface of shared-components
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ButtonComponent, CalenderComponent, FileuploadComponent, GridComponent, SharedComponentModule };
//# sourceMappingURL=shared-components-sample.mjs.map
